"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.arrow = void 0;
var store_1 = require("svelte/store");
var dom_1 = require("@floating-ui/dom");
function arrow(options) {
    function isStore(value) {
        return Object.prototype.hasOwnProperty.call(value, "subscribe");
    }
    return {
        name: "arrow",
        options: options,
        fn: function (args) {
            if (isStore(options.element)) {
                var element = (0, store_1.get)(options.element);
                if (element) {
                    (0, dom_1.arrow)({
                        element: element,
                        padding: options.padding
                    }).fn(args);
                }
                return {};
            }
            else if (options.element) {
                return (0, dom_1.arrow)({
                    element: options.element,
                    padding: options.padding
                });
            }
            return {};
        }
    };
}
exports.arrow = arrow;
