"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createFloatingActions = void 0;
var dom_1 = require("@floating-ui/dom");
function createFloatingActions(initOptions) {
    var referenceElement;
    var contentElement;
    var options = initOptions;
    var updatePosition = function (updateOptions) {
        if (referenceElement && contentElement) {
            options = __assign(__assign({}, initOptions), updateOptions);
            (0, dom_1.computePosition)(referenceElement, contentElement, options)
                .then(function (v) {
                Object.assign(contentElement.style, {
                    position: v.strategy,
                    left: "".concat(v.x, "px"),
                    top: "".concat(v.y, "px"),
                });
                options.onComputed && options.onComputed(v);
            });
        }
    };
    var referenceAction = function (node) {
        referenceElement = node;
        updatePosition();
    };
    var contentAction = function (node, contentOptions) {
        contentElement = node;
        options = __assign(__assign({}, initOptions), contentOptions);
        var cleanupAutoUpdate = options.autoUpdate ? (0, dom_1.autoUpdate)(referenceElement, contentElement, updatePosition, options.autoUpdate === true ? {} : options.autoUpdate) : undefined;
        if (!cleanupAutoUpdate)
            updatePosition();
        return {
            update: updatePosition,
            destroy: cleanupAutoUpdate
        };
    };
    return [
        referenceAction,
        contentAction,
        updatePosition // Method to update the content position
    ];
}
exports.createFloatingActions = createFloatingActions;
